﻿using System;
using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.Documents.Fixed.UI.Extensibility;
using System.Windows.Shapes;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Documents.Fixed.Model;

namespace CustomUILayer
{
    public partial class MainPage : UserControl
    {
        private Highlights highlights;

        
        public MainPage()
        {
            this.highlights = new Highlights();
            ExtensibilityManager.RegisterLayersBuilder(new CustomUILayersBuilder(this.highlights));

            InitializeComponent();

            this.pdfViewer.DocumentChanged += this.PdfViewer_DocumentChanged;
        }

        private void PdfViewer_DocumentChanged(object sender, EventArgs e)
        {
            if (this.pdfViewer.Document == null)
            {
                return;
            }
            foreach (RadFixedPage page in this.pdfViewer.Document.Pages)
            {
                this.highlights[page] = new PathGeometry { FillRule = FillRule.Nonzero };
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (this.pdfViewer.Document == null || this.pdfViewer.Document.Selection.IsEmpty)
            {
                return;
            }
            RadFixedPage start = this.pdfViewer.Document.Selection.StartPosition.Page;
            RadFixedPage end = this.pdfViewer.Document.Selection.EndPosition.Page;

            if (start.PageNo > end.PageNo)
            {
                RadFixedPage t = start;
                start = end;
                end = t;
            }

            for (int i = start.PageNo - 1; i <= end.PageNo - 1; i++)
            {
                PathGeometry g = this.highlights[this.pdfViewer.Document.Pages[i]];
                PathGeometry s = this.pdfViewer.Document.Selection.GetSelectionGeometry(this.pdfViewer.Document.Pages[i]);

                while (s.Figures.Count > 0)
                {
                    PathFigure pf = s.Figures[0];
                    s.Figures.RemoveAt(0);
                    g.Figures.Add(pf);
                }
            }
        }
    }
}
