﻿using System;
using System.Windows.Controls;
using Telerik.Windows.Documents.Fixed.UI.Layers;

namespace CustomUILayer
{
    public class PageNoUILayer : IUILayer
    {
        #region Consts

        public static readonly string PageNoUILayerName = "PageNoUILayer";

        #endregion


        #region Constructors

        public PageNoUILayer()
        {
            this.uiElement = new Canvas();
        }

        #endregion


        #region Fields

        private readonly Canvas uiElement;

        #endregion


        #region Properties

        public Canvas UIElement
        {
            get { return this.uiElement; }
        }

        public string Name
        {
            get { return PageNoUILayerName; }
        }

        #endregion


        #region Methods
        #endregion

        public void Clear()
        {
            this.uiElement.Children.Clear();
        }

        public void Initialize(UILayerInitializeContext context)
        {
            TextBlock tb = new TextBlock();
            tb.Text = string.Format("This is page {0}",  context.Page.PageNo);

            this.uiElement.Children.Add(tb);
            Canvas.SetLeft(tb, 10);
            Canvas.SetTop(tb, 10);
        }

      

        public void Update(UILayerUpdateContext context)
        {
        }

        
    }
}
